AppMobi.Facebook = function() {
   this.isSessionValid = false;

   var _willHandleUserTouchingLink = false;
   this.__defineGetter__("willHandleUserTouchingLink", function(){
       return _willHandleUserTouchingLink;
   });

   this.__defineSetter__("willHandleUserTouchingLink", function(val){
               AppMobi.exec("AppMobiFacebook.setWillHandleUserTouchingLink", val);
       _willHandleUserTouchingLink = val;
   });

       var _nextRequestId = 0;
   this.__defineGetter__("nextRequestId", function(){
       return _nextRequestId++;
   });
}

AppMobi.Facebook.prototype.login = function(permissions) {
       //permissions is a '|' separated list of permissions - no validation is performed
       AppMobi.exec("AppMobiFacebook.login", permissions);
}

AppMobi.Facebook.prototype.logout = function() {
       AppMobi.exec("AppMobiFacebook.logout");
}

AppMobi.Facebook.prototype.requestWithRestAPI = function(methodName, parameters, httpMethod) {
       var requestId = AppMobi.facebook.nextRequestId;
       AppMobi.exec("AppMobiFacebook.requestWithRestAPI", methodName, parameters, httpMethod, requestId);
       return requestId;
}

AppMobi.Facebook.prototype.requestWithGraphAPI = function(path, parameters, httpMethod) {
       AppMobi.exec("AppMobiFacebook.requestWithGraphAPI", path, parameters, httpMethod, AppMobi.facebook.nextRequestId);
}

AppMobi.Facebook.prototype.showAppRequestDialog = function(parameters) {
       AppMobi.exec("AppMobiFacebook.showAppRequestDialog", parameters);
}

AppMobi.Facebook.prototype.showNewsFeedDialog = function(parameters) {
       AppMobi.exec("AppMobiFacebook.showNewsFeedDialog", parameters);
}

AppMobi.Facebook.prototype.enableFrictionlessRequests = function() {
       AppMobi.exec("AppMobiFacebook.enableFrictionlessRequests");
}


#import "AppMobiFacebook.h"
#import "AppMobiWebView.h"
#import "AppMobiDelegate.h"
#import "FBDelegate.h"

@implementation AppMobiFacebook


- (id)initWithWebView:(AppMobiWebView *)webview
{
       self = (AppMobiFacebook *) [super initWithWebView:webview];

       [FBDelegate addSessionListener:self];

       request2Id = [NSMutableDictionary dictionary];
       willHandleUserTouchingLink = NO;

       return self;
}

- (void)injectJS:(NSString *)js {
       [webView injectJS:js];
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#pragma mark javascript interface:
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

- (void)login:(NSMutableArray*)arguments withDict:(NSMutableDictionary*)options {

       //optional param permissions is a '|' separated list - nil is a valid argument to authorize
       NSArray *permissions = [NSArray array];
       if ([[arguments objectAtIndex:0] length]>0) {
               permissions = [[arguments objectAtIndex:0] componentsSeparatedByString:@"|"];
               //validate?
       }

       [[FBDelegate sharedInstance] login:permissions];
}

- (void)logout:(NSMutableArray*)arguments withDict:(NSMutableDictionary*)options {
       [[FBDelegate sharedInstance] logout];//should use version with parameter to handle 3.1.3?
}

- (void)requestWithRestAPI:(NSMutableArray*)arguments withDict:(NSMutableDictionary*)options {
       NSString *methodName = [arguments objectAtIndex:0];
       NSMutableDictionary *params = [NSMutableDictionary dictionary];
       if ([[arguments objectAtIndex:1] length]>0) {
               //validate/error checking?
               SBJSON *jsonParser = [[SBJSON new] autorelease];
               params = [jsonParser objectWithString:[arguments objectAtIndex:1]];
       }
       NSString *httpMethod = [arguments objectAtIndex:2];
       NSString *requestId = [arguments objectAtIndex:3];

       FBRequest *request = [[FBDelegate sharedInstance].fb requestWithMethodName:methodName andParams:params andHttpMethod:httpMethod andDelegate:self];
       [request2Id setObject:requestId forKey:request];
}

- (void)requestWithGraphAPI:(NSMutableArray*)arguments withDict:(NSMutableDictionary*)options {
       NSString *path = [arguments objectAtIndex:0];
       NSMutableDictionary *params = [NSMutableDictionary dictionary];
       if ([[arguments objectAtIndex:1] length]>0) {
               //validate/error checking?
               SBJSON *jsonParser = [[SBJSON new] autorelease];
               params = [jsonParser objectWithString:[arguments objectAtIndex:1]];
       }
       NSString *httpMethod = [arguments objectAtIndex:2];
       NSString *requestId = [arguments objectAtIndex:3];

       FBRequest *request = [[FBDelegate sharedInstance].fb requestWithGraphPath:path andParams:params andHttpMethod:httpMethod andDelegate:self];
       [request2Id setObject:requestId forKey:request];
}

//title, message, filters, to, notification_text, data
- (void)showAppRequestDialog:(NSMutableArray*)arguments withDict:(NSMutableDictionary*)options {
       NSMutableDictionary *params = [NSMutableDictionary dictionary];
       if ([[arguments objectAtIndex:0] length]>0) {
               //validate/error checking?
               SBJSON *jsonParser = [[SBJSON new] autorelease];
               params = [jsonParser objectWithString:[arguments objectAtIndex:0]];
       }
       [[FBDelegate sharedInstance].fb dialog:@"apprequests" andParams:params andDelegate:self];
}

//from, to, link, picture, source, name, caption, description,
properties(JSON), actions(JSON), ref
//message
- (void)showNewsFeedDialog:(NSMutableArray*)arguments withDict:(NSMutableDictionary*)options {
       NSMutableDictionary *params = [NSMutableDictionary dictionary];
       if ([[arguments objectAtIndex:0] length]>0) {
               //validate/error checking?
               SBJSON *jsonParser = [[SBJSON new] autorelease];
               params = [jsonParser objectWithString:[arguments objectAtIndex:0]];
       }
       [[FBDelegate sharedInstance].fb dialog:@"feed" andParams:params andDelegate:self];
}

- (void)enableFrictionlessRequests:(NSMutableArray*)arguments withDict:(NSMutableDictionary*)options {
       [[FBDelegate sharedInstance].fb enableFrictionlessRequests];
}

- (void)setWillHandleUserTouchingLink:(NSMutableArray*)arguments  withDict:(NSMutableDictionary*)options {
       willHandleUserTouchingLink = [[arguments objectAtIndex:0] boolValue];
}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#pragma mark FBSessionDelegate Methods:
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

/**
 * Called when the user successfully logged in.
 */
- (void)fbDidLogin {
       //set AppMobi.facebook.isSessionValid to true, fire event
       NSString * js = [NSString stringWithFormat:@"var e = document.createEvent('Events');e.initEvent('appMobi.facebook.login',true,true);document.dispatchEvent(e);"];
       [self injectJS:js];
}



/**
 * Called when the user dismissed the dialog without logging in.
 */
- (void)fbDidNotLogin:(BOOL)cancelled {
       //do nothing
}

/**
 * Called after the access token was extended. If your application has any
 * references to the previous access token (for example, if your application
 * stores the previous access token in persistent storage), your application
 * should overwrite the old access token with the new one in this method.
 * See extendAccessToken for more details.
 */
- (void)fbDidExtendToken:(NSString*)accessToken expiresAt:(NSDate*)expiresAt {
       //do nothing
}

/**
 * Called when the user logged out.
 */
- (void)fbDidLogout {
       //set AppMobi.facebook.isSessionValid to false, fire event
       NSString * js = [NSString stringWithFormat:@"var e = document.createEvent('Events');e.initEvent('appMobi.facebook.logout',true,true);document.dispatchEvent(e);"];
       [self injectJS:js];
}

/**
 * Called when the current session has expired. This might happen when:
 *  - the access token expired
 *  - the app has been disabled
 *  - the user revoked the app's permissions
 *  - the user changed his or her password
 */
- (void)fbSessionInvalidated {
       //set AppMobi.facebook.isSessionValid to false, fire event
       NSString * js = [NSString stringWithFormat: @"var e = document.createEvent('Events');e.initEvent('appMobi.facebook.sessioninvalidated',true,true);document.dispatchEvent(e);"];
       [self injectJS:js];
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#pragma mark FBRequestDelegate Methods:
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

/**
 * Called when an error prevents the request from completing successfully.
 */
- (void)request:(FBRequest *)request didFailWithError:(NSError *)error {
       //get id of request
       NSString *requestId = [request2Id objectForKey:request];

       NSLog(@"request:didFailWithError for request %@, response: %@", requestId, [error description]);

       //make js
       NSString * js = [NSString stringWithFormat:@"var e = document.createEvent('Events');e.initEvent('appMobi.facebook.request.response',true,true);e.id=%@;e.success=false;e.data='%@';document.dispatchEvent(e);", requestId, [error.userInfo objectForKey:@"error_msg"]];
       [self injectJS:js];
}

/**
 * Called when a request returns and its response has been parsed into
 * an object.
 *
 * The resulting object may be a dictionary, an array, a string, or a number,
 * depending on thee format of the API response.
 */
- (void)request:(FBRequest *)request didLoad:(id)result {
       //get id of request
       NSString *requestId = [request2Id objectForKey:request];

       NSLog(@"request:didLoad for request %@", requestId);

       //do nothing
}

/**
 * Called just before the request is sent to the server.
 */
- (void)requestLoading:(FBRequest *)request {
       //get id of request
       NSString *requestId = [request2Id objectForKey:request];

       NSLog(@"request:requestLoading for request %@", requestId);

       //do nothing
}

/**
 * Called when the server responds and begins to send back data.
 */
- (void)request:(FBRequest *)request didReceiveResponse:(NSURLResponse
*)response {
       //get id of request
       NSString *requestId = [request2Id objectForKey:request];

       NSLog(@"request:didReceiveResponse for request %@", requestId);

       //do nothing
}

/**
 * Called when a request returns a response.
 *
 * The result object is the raw response from the server of type NSData
 */
- (void)request:(FBRequest *)request didLoadRawResponse:(NSData *)data {
       //get id of request
       NSString *requestId = [request2Id objectForKey:request];
       //get JSON string for response
       NSString* responseString = [[[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding] autorelease];

       NSLog(@"request:didLoadRawResponse for request %@, response: %@", requestId, responseString);

       //make js
       NSString * js = [NSString stringWithFormat: @"var e = document.createEvent('Events');e.initEvent('appMobi.facebook.request.response',true,true);e.id=%@;e.success=true;e.data='%@';document.dispatchEvent(e);", requestId, responseString];
       [self injectJS:js];
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#pragma mark FBdialogDelegate Methods:
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

/**
 * Called when the dialog succeeds and is about to be dismissed.
 */
- (void)dialogDidComplete:(FBDialog *)dialog {
       NSLog(@"%@", @"dialogDidComplete");

       //inject event
       NSString * js = [NSString stringWithFormat:@"var e = document.createEvent('Events');e.initEvent('appMobi.facebook.dialog.complete',true,true);e.url='';document.dispatchEvent(e);"];
       [self injectJS:js];
}

/**
 * Called when the dialog succeeds with a returning url.
 */
- (void)dialogCompleteWithUrl:(NSURL *)url {
       NSLog(@"%@", @"dialogCompleteWithUrl");

       //inject event
       NSString * js = [NSString stringWithFormat:@"var e = document.createEvent('Events');e.initEvent('appMobi.facebook.dialog.complete',true,true);e.url='%@';document.dispatchEvent(e);", url];
       [self injectJS:js];
}

/**
 * Called when the dialog get canceled by the user.
 */
- (void)dialogDidNotCompleteWithUrl:(NSURL *)url {
       NSLog(@"%@", @"dialogDidNotCompleteWithUrl");

       //inject event
       NSString * js = [NSString stringWithFormat:@"var e = document.createEvent('Events');e.initEvent('appMobi.facebook.dialog.didNotComplete',true,true);e.url='%@';document.dispatchEvent(e);", url];
       [self injectJS:js];
}

/**
 * Called when the dialog is cancelled and is about to be dismissed.
 */
- (void)dialogDidNotComplete:(FBDialog *)dialog {
       NSLog(@"%@", @"dialogDidNotComplete");

       //inject event
       NSString * js = [NSString stringWithFormat:@"var e = document.createEvent('Events');e.initEvent('appMobi.facebook.dialog.didNotComplete',true,true);e.url='';document.dispatchEvent(e);"];
       [self injectJS:js];
}

/**
 * Called when dialog failed to load due to an error.
 */
- (void)dialog:(FBDialog*)dialog didFailWithError:(NSError *)error {
       NSLog(@"%@", @"didFailWithError");

       //inject event
       NSString * js = [NSString stringWithFormat:@"var e = document.createEvent('Events');e.initEvent('appMobi.facebook.dialog.didFail',true,true);e.error='%@';document.dispatchEvent(e);", [error.userInfo objectForKey:@"error_msg"]];
       [self injectJS:js];
}

/**
 * Asks if a link touched by a user should be opened in an external browser.
 *
 * If a user touches a link, the default behavior is to open the link
in the Safari browser,
 * which will cause your app to quit.  You may want to prevent this
from happening, open the link
 * in your own internal browser, or perhaps warn the user that they
are about to leave your app.
 * If so, implement this method on your delegate and return NO.  If
you warn the user, you
 * should hold onto the URL and once you have received their
acknowledgement open the URL yourself
 * using [[UIApplication sharedApplication] openURL:].
 */
- (BOOL)dialog:(FBDialog*)dialog shouldOpenURLInExternalBrowser:(NSURL *)url {
       NSLog(@"dialog:shouldOpenURLInExternalBrowser: %@", url);

       //inject event
       NSString * js = [NSString stringWithFormat:@"var e = document.createEvent('Events');e.initEvent('appMobi.facebook.userClickedLink',true,true);e.url='%@';document.dispatchEvent(e);", url];
       [self injectJS:js];

       return !willHandleUserTouchingLink;
}

@end