// Copyright 2012 appMobi -- All rights reserved

function showModal(content){
	$("#modal_container").show();
	$("#modal_div").html(content);
}

function hideModal(){
	$("#modal_container").hide();
	$("#modal_div").html('');
	window.scrollTo(0,1);
}

function checkGroupLimit()
{
	//( $(CHAT_ROOMS).count() >= 6 ) ? $('#addGroupBtn').hide() : $('#addGroupBtn').show();
	$('#addGroupBtn').show();
}

function remoteDataReceived(e)
{
	CALLBACKS[e.id](e);
}
document.addEventListener("appMobi.device.remote.data",remoteDataReceived,false);

CALLBACKS = {};

CALLBACKS['stations'] = function(e)
{
	var response = eval('('+e.response+')');
	if( typeof(response) == "undefined" || typeof(response.rtn) == "undefined" || response.rtn != "ok" )
	{
		e.success = false;
	}

	if( e.success == true )
	{
		for( var i = 0; i < response.stations.length; i++ )
		{
			var id = response.stations[i].id;
			ALL_STATIONS[id] = response.stations[i];
		}
		if( FAV_STATION.length > 0 ) addFavoriteStation();
		saveAppState();
	}
	updateStationsUI();
}

CALLBACKS['update'] = function(e)
{
	parser = new DOMParser();
	xmlDoc = parser.parseFromString(e.response,"text/xml");
	var header = xmlDoc.childNodes[0];
	var response = header.getAttribute("return");
	if( typeof(response) == "undefined" || response != "ok" )
	{
		e.success = false;
	}

	notifications = [];
	var messages = xmlDoc.getElementsByTagName("message");
	for( var i = 0; i < messages.length; i++ )
	{
		var note = {};
		var message = messages[i];
		for( var j = 0; j < message.attributes.length; j++ )
		{
			note[message.attributes[j].nodeName] = message.attributes[j].nodeValue;
		}
		var datastr = unescape( note.data );
		note.data = eval('('+datastr+')');
		notifications.push( note );
	}

	var ex = {};
	ex.success = e.success;
	ex.notifications = notifications;
	ex.user = ACTIVE_STATION;
	chatReceived(ex);
}

function checkStationSelected(event){
    event.preventDefault();
    event.stopPropagation();
    if(ACTIVE_STATION.length == 0)
    {
        event.preventDefault();
        event.stopPropagation();
        return alert("Please select a station first");
    }
    $.ui.loadContent("#player");
    autoScrollChatMessages();
}

function setupStationsUI()
{
	if( ACTIVE_STATION.length == 0 )
	{
		$('#station_resume').addClass('playerBarHide');
		$('#stationsScrollerContainer').addClass('stationsScrollerContainerNoPlayBar');
		$('#chatHeader').hide();
        $('img.playerControl').hide();
	}
	else
	{
		$('#station_resume').show();
		$('#chatHeader').show();
		$('#station_resume_name').html(ALL_STATIONS[ACTIVE_STATION].name);
		$('#station_resume_image').attr('src', ALL_STATIONS[ACTIVE_STATION].image );
		$('#stationsScrollerContainer').css('top','50px');
		$('#stationsScrollerContainer').addClass('stationsScrollerContainer');

		setPlayerBar(BAR_STATE.RESUME);
		$('#player_station_toggle').show();
		$('#player_station_resume').show();
        $("#player_station_ping").show();
		$('#player_station_name').html(ALL_STATIONS[ACTIVE_STATION].name);
		$('#player_station_image').attr('src', ALL_STATIONS[ACTIVE_STATION].image);
		$('#player_station_chat').html(ALL_STATIONS[ACTIVE_STATION].name);

		$('#chatHeader').show();
		$('#station_resume').removeClass('playerBarHide');
	}
}

function updateStationsUI()
{
	var newsstr = "";
	var musicstr = "";
	var sportsstr = "";
	var popularstr = "";
	var favstr = "";

	for( station in ALL_STATIONS )
	{
		var stat = ALL_STATIONS[station];
		var statstr = "<li onclick='playStation(\"" + stat.id + "\");' style='position:relative'><img style='display:none;height:40px; top:5px; witdh:40px;' src='" + stat.image + "'><a href='javascript:;' style='background-color: transparent;'>" + stat.name + "</a><img class='playSmall' src='images/play-sm.png' /></li>";
		if( stat.id == 0 ) // favorite shoutcast from user
		{
			favstr += statstr;
		}
		else if( stat.type == "Sports" )
		{
			sportsstr += statstr;
		}
		else if( stat.type == "Music" )
		{
			musicstr += statstr;
		}
		else if( stat.type == "Talk" )
		{
			newsstr += statstr;
		}

		if( typeof( stat.popular ) != "undefined" && stat.popular == "1" )
		{
			popularstr += statstr;
		}
	}

	$('#newsSubItems').empty();
	$('#newsSubItems').append($(newsstr));
	$('#musicSubItems').empty();
	$('#musicSubItems').append($(musicstr));
	$('#sportsSubItems').empty();
	$('#sportsSubItems').append($(sportsstr));
	$('#popularSubItems').empty();
	$('#popularSubItems').append($(popularstr));
	
	if( favstr.length > 0 )
	{
		$('#favSubItems').empty();
		$('#favSubItems').append($(favstr));
	}
}

playing = false;
starting = false;
started = false;
stationClicked=false;
function playPauseToggle()
{
	if( starting == true ) return;

	if( started == false )
	{
		started = true;
		AppMobi.player.startShoutcast(ALL_STATIONS[ACTIVE_STATION].url);
        setPlayerBar(BAR_STATE.CONNECTING);
	}
	else
	{
		if( playing == true )
		{
			AppMobi.player.pause();
            setPlayerBar(BAR_STATE.PAUSED);
		}
		else
		{
			AppMobi.player.play();
            setPlayerBar(BAR_STATE.PLAYING);
		}
	}
	playing = !playing;
}

function startReceived(e)
{
	playing = true;
	starting = false;
	setPlayerBar(BAR_STATE.PLAYING);
    stationClicked=false;
}

function errorReceived(e)
{
	AppMobi.player.stop();
	starting = false;
	playing = false;
	setPlayerBar(BAR_STATE.ERROR);
	AppMobi.notification.alert('Error playing this station. Try again later.', 'Station Error');
    stationClicked=false;
}

var BACKGROUND = false;
function suspendReceived(e)
{
	BACKGROUND = true;
}
document.addEventListener("appMobi.device.suspend",suspendReceived,false);

function resumeReceived(e)
{
	BACKGROUND = false;
}
document.addEventListener("appMobi.device.resume",resumeReceived,false);

function pauseReceived(e)
{
	if( BACKGROUND == false ) return;
	playing = false;
	setPlayerBar(BAR_STATE.PAUSED);
}
document.addEventListener("appMobi.player.shoutcast.pause",pauseReceived,false);

var numOfDots = 1;
var connectInterval = null;
String.prototype.repeat = function(num) {
    return new Array(isNaN(num) ? 1 : ++num).join(this);
}

var BAR_STATE = {
    CONNECTING: 1,
    PLAYING: 2,
    PAUSED: 3,
    RESUME: 4,
    ERROR: 5
};

function setPlayerBar(state) {
    switch (state) {
        case BAR_STATE.CONNECTING:     // Connecting
            $('#player_station_resume').text("Connecting" + ".".repeat(numOfDots));
            $('img.playerControl').attr("src","images/stop.png");
            connectInterval = setInterval(function () {
                numOfDots = ((numOfDots+1) > 5) ? 1 : numOfDots+1;
                $('#player_station_resume').text("Connecting" + ".".repeat(numOfDots));
                $('#station_station_resume').text("Connecting" + ".".repeat(numOfDots));
            }, 500);
            break;
        case BAR_STATE.PLAYING:     // Playing
            $('#station_station_resume').text("Playing");
            $('#player_station_resume').text("Playing");
	        $('#player_station_toggle').removeClass("play").addClass("pause");
            $('img.playerControl').attr("src","images/pause.png");
            break;
        case BAR_STATE.PAUSED:     // Paused
            $('#station_station_resume').text("Paused");
            $('#player_station_resume').text("Paused");
	        $('#player_station_toggle').removeClass("pause").addClass("play");
            $('img.playerControl').attr("src","images/play.png");
            break;
        case BAR_STATE.RESUME:     // Resume
            $('#station_station_resume').text("Resume");
            $('#player_station_resume').text("Resume");
	        $('#player_station_toggle').removeClass("pause").addClass("play");
            $('img.playerControl').attr("src","images/play.png");
            break;
        case BAR_STATE.ERROR:     // Error
            $('#station_station_resume').text("Error Playing");
            $('#player_station_resume').text("Error Playing");
	        $('#player_station_toggle').removeClass("pause").addClass("play");
            $('img.playerControl').attr("src","images/play.png");
            break;
        default:
    }

    if (state != BAR_STATE.CONNECTING && connectInterval)
        clearInterval(connectInterval);
}

function checkStationLoading(event){
    event.preventDefault();
    event.stopPropagation();

    if(stationClicked)
        return alert("Please wait while we attempt to load the station");

    $.ui.loadContent("#stations");
    return;
}

function playStation(station)
{
    stationClicked=true;
    setPlayerBar(BAR_STATE.CONNECTING);
	AppMobi.player.stop();
	AppMobi.player.startShoutcast(ALL_STATIONS[station].url);
	ACTIVE_STATION = station;
	AppMobi.cache.setCookie("active_station", ACTIVE_STATION, -1);
	playing = true;
	starting = true;
	started = true;

	if( ACTIVE_CHAT.length == 0 || ACTIVE_CHAT.indexOf('-_-') == -1 )
	{
		ACTIVE_CHAT = ACTIVE_STATION + "";
		$('#player_station_chat').html(ALL_STATIONS[station].name);
	}
	resetChatList( ( typeof( GROUP_CHATS[ACTIVE_STATION] ) == "undefined" || $(GROUP_CHATS[ACTIVE_STATION]).count() == 0 ) && - ACTIVE_CHAT );
	LAST_ID = 0;
	GROUP_CHATS[ACTIVE_STATION] = {};
	countdown = 0;
	saveAppState();

	$('#player_station_toggle').show();
	$('#player_station_resume').show();
	$('#player_station_name').html(ALL_STATIONS[station].name);
	$('#player_station_image').attr('src', ALL_STATIONS[station].image);
    $("#player_station_ping").show();
	$('#station_resume').show();
	$('#station_resume_name').html(ALL_STATIONS[ACTIVE_STATION].name);
	$('#station_resume_image').attr('src', ALL_STATIONS[ACTIVE_STATION].image );

	$('#chatHeader').show();
    $('img.playerControl').show();
	$('#station_resume').removeClass('playerBarHide');
    if( window.innerWidth < 600 )
        $('#stationsScrollerContainer').css('top','100px');
    $('#stationsScrollerContainer').removeClass('stationsScrollerContainerNoPlayBar');
	$.ui.loadContent("#player");
	updateChatMessages();

	if( IS_TUTORIAL == true && TUTORIAL_STEP == 1 ) showTutorial( ++TUTORIAL_STEP );
}
document.addEventListener("appMobi.player.shoutcast.start",startReceived,false);
document.addEventListener("appMobi.player.shoutcast.error",errorReceived,false);
document.addEventListener("appMobi.player.shoutcast.busy",errorReceived,false);

var timeractive = false;
function updateTimer()
{
	countdown--;
	if( countdown < 0 ) countdown = 0;
	if( countdown > TIMER_RESET ) countdown = TIMER_RESET;

	padding = countdown < 10?"0":"";
    $('#board_down').html(padding+countdown+"s");

	if( countdown == 0 ) { timeractive = false; updateChat(ACTIVE_STATION); }
	else setTimeout("updateTimer();", 1000);
}

function chatReceived(e)
{
	var chatMessages = [];
	if( typeof( GROUP_CHATS[ACTIVE_STATION] ) == "undefined" ) GROUP_CHATS[ACTIVE_STATION] = {};
	for(var i = 0; i < e.notifications.length; i++)
	{
		try
		{
			var note = e.notifications[i];
			var datastr = unescape( note.data );
			note.data = eval('('+datastr+')');
			GROUP_CHATS[ACTIVE_STATION][note.id] = note;
			LAST_ID = (note.id > LAST_ID)?note.id:LAST_ID; //this was inside of the If statement below... I think it should be here though

			if( ACTIVE_STATION == ACTIVE_CHAT)
				chatMessages.push(note);
		}
		catch(ex)
		{
			console.log("bad message in chatReceived -- " + ex.message);
		}
	}

	//DISPLAY NEW CHAT MESSAGES IF CURRENT STATION IS ACTIVE CHAT
	//============================================================================
	if(chatMessages.length > 0)
	{
		chatMessages.sort(sortChatMessages);
		for(chat in chatMessages)
			addChatMessage(chatMessages[chat]);
		  //if( chatMessages[chat].id > LAST_ID ) LAST_ID = chatMessages[chat].id;
		autoScrollChatMessages();
	}
	//============================================================================

	if( timeractive == false )
	{
		timeractive = true;
		countdown = 91;
		updateTimer();
	}
}
document.addEventListener("appMobi.notification.push.userrefresh", chatReceived, false);

function updateChat(station)
{
	if( station.length == 0 && timeractive == false )
	{
		timeractive = true;
		countdown = TIMER_RESET + 1;
		updateTimer();
		return;
	}

	AppMobi.notification.refreshUserPushNotifications("station" + station, "password" + station, "device" + station, LAST_ID);
}

function addChatMessage(note)
{
	if( typeof( $('#chatmsg_'+note.id).get() ) != "undefined" ) return;

	var chatstr = "";
	var notedata = note.data;
	if( typeof( notedata.refr ) == "undefined" || notedata.refr.length == 0 )
	{
		chatstr += "<li id='chatmsg_" + note.id + "' class='logmsg chatmsg chatMain'>";
		chatstr += "<span class='chatName'>" + notedata.name + ": </span><span>" + note.msg + "</span></li>";
		$('#chatlist').append($(chatstr));
	}
	else
	{
		var masterstr = 'chatmsg_'+notedata.refr;
		var master = $('#' + masterstr);
		if( typeof( master.get() ) != "undefined" )
		{
			chatstr += "<li id='chatmsg_" + note.id + "' class='logmsg chatmsg chatSub " + masterstr + "'><img src='images/reply_bullet.png' style='vertical-align:middle; margin-right:5px;' />";
			chatstr += "<span class='chatName'>" + notedata.name + ": </span><span>" + note.msg + "</span></li>";
			$(chatstr).insertAfter(master);
			$('.'+masterstr).show();
		}
	}
}

function resetChatList(prompt)
{
	var chatstr = "<ul id='chatlist'></ul>";
	$('#chatScroller').empty();
	$('#chatScroller').append($(chatstr));

	if( prompt == true )
	{
		var chatstr = "<li class='logmsg chatmsg chatMain'><span class='chatName'>STATION: </span>Touch above to add your own commentary. Touch individual comments to respond, follow users or collapse threads.</li>";
		$('#chatlist').append($(chatstr));
	}
}

function sortByTime(a, b) {
    var x = parseInt(a.seconds);
    var y = parseInt(b.seconds);
    return ((x < y) ? -1 : ((x > y) ? 1 : 0));
}

function getTimecode()
{
	var day = new Date();
	var time = day.getTime() - ( day.getTimezoneOffset() * 60 );
	time = parseInt( time / 1000 );
	return time;
}

function groupSendChat()
{
	var time = getTimecode();
	var chatid = time + "-" + parseInt(Math.random()*104729) % 997;
	var ref = (curChat == "nochatmsg" ) ? "" : curChat.substring(8);
	var message = $('#chatmsg').val();
	$('#chatmsg').val("");

	var filter = "[s1 LIKE %" + ACTIVE_CHAT + "%]";
	sendPush( message, time, chatid, ACTIVE_CHAT, AppMobi.device.uuid, USER_NAME, 'groupchat', filter, "", ref, false );
}

function stationSendChat()
{
	var time = getTimecode();
	var chatid = time + "-" + parseInt(Math.random()*104729) % 997;
	var ref = (curChat == "nochatmsg" ) ? "" : curChat.substring(8);
	var message = $('#chatmsg').val();
	$('#chatmsg').val("");

	var filter = "[n1=" + ACTIVE_CHAT + "]";
	sendPush( message, time, chatid, ACTIVE_CHAT, AppMobi.device.uuid, USER_NAME, 'stationchat', filter, "", ref, true );

	var filter = "[s2 LIKE %" + AppMobi.device.uuid + "%]";
	sendPush( message, time, chatid, ACTIVE_CHAT, AppMobi.device.uuid, USER_NAME, 'follow', filter, "", "", false );

	if( ref.length > 0 )
	{
		var chat = GROUP_CHATS[ACTIVE_CHAT][ref];
		var filter = "[s3=" + chat.data.user + "]";
		sendPush( "Congrats", time, "reward", ACTIVE_CHAT, AppMobi.device.uuid, USER_NAME, 'reply', filter, chat.data.user, "", false );
	}

	COMMENT_LIST[ACTIVE_CHAT] = 1;
	if( $(COMMENT_LIST).count() > 4 && Achievements.earned(ACHIEVEMENT_COMMENT_5CHANNEL) == false )
	{
		Achievements.earn(ACHIEVEMENT_COMMENT_5CHANNEL);
		AppMobi.notification.alert("You've just earned the QUINTO COMMENTER badge", "Congratulations!", "OK");
	}

	countdown = 0;
}

function sendChat()
{
	if( ACTIVE_CHAT.indexOf('-_-') == -1 )
	{
		if( COMMENT_COUNT < 1 )
		{
			AppMobi.notification.alert("Touch 'Get More' to find out how to get more comments.", 'No Comments');
			return false;
		}

		stationSendChat();
		if( IS_TUTORIAL == false )
		{
			if( COMMENT_INFINITY == 0 ) COMMENT_COUNT--;
			COMMENT_SENT++;
			if( Achievements.earned(ACHIEVEMENT_2_CENTS) == false )
			{
				Achievements.earn(ACHIEVEMENT_2_CENTS);
				AppMobi.notification.alert("You've just earned the YOUR OWN 2 CENTS badge", "Congratulations!", "OK");
			}
			if( COMMENT_SENT > 100 && Achievements.earned(ACHIEVEMENT_COMMENT_CENTURY) == false )
			{
				Achievements.earn(ACHIEVEMENT_COMMENT_CENTURY);
				AppMobi.notification.alert("You've just earned the COMMENT OF THE CENTURY badge", "Congratulations!", "OK");
			}
			$('#num_comments_sent').html(COMMENT_SENT);
			$('#num_comments_left').html( (COMMENT_INFINITY == 1 ) ? "&#8734" : COMMENT_COUNT );
			$('#num_comments_rem').html( (COMMENT_INFINITY == 1 ) ? "&#8734" : COMMENT_COUNT );
		}

		if( typeof( LeaderBoardData) != "undefined")
		{
			var station = LeaderBoardData[ACTIVE_STATION];
			var score = 0;
			if( typeof( station ) != "undefined") score = station.player.score;
			playMobi.leaderboard.save({score : (score + 25), mode : ACTIVE_STATION, notes : 'ChatSent'});
			setTimeout("getLeaderboards();", 0);
		}
		saveAppState();
	}
	else
	{
		groupSendChat();
	}

	return true;
}

function cancelChat()
{
	$('#chatmsg').val("");
    $('#chatForm').hide();
}

function saveAppState(suppressBackup)
{
	var statstr = JSON.stringify( ALL_STATIONS );
	AppMobi.cache.setCookie("all_stations", statstr, -1);
	AppMobi.cache.setCookie('comment_count', COMMENT_COUNT, -1);
	AppMobi.cache.setCookie('comment_sent', COMMENT_SENT, -1);
	AppMobi.cache.setCookie('comment_infinity', COMMENT_INFINITY, -1);
	AppMobi.cache.setCookie("active_station", ACTIVE_STATION, -1);
	AppMobi.cache.setCookie("active_chat", ACTIVE_CHAT, -1);
	AppMobi.cache.setCookie("earn_prompt", EARN_PROMPT, -1);
	AppMobi.cache.setCookie('user_name', USER_NAME, -1);
	AppMobi.cache.setCookie('fav_station', FAV_STATION, -1);
	AppMobi.cache.setCookie('tutorial_done', TUTORIAL_DONE, -1);
	var liststr = JSON.stringify( COMMENT_LIST );
	AppMobi.cache.setCookie('comment_list', liststr,-1);
	var chatstr = JSON.stringify( CHAT_ROOMS );
	AppMobi.cache.setCookie('chat_rooms', chatstr,-1);
	var groupstr = JSON.stringify( GROUP_CHATS );
	AppMobi.cache.setCookie("group_chats", groupstr, -1);
	var followstr = JSON.stringify( FOLLOWS );
	AppMobi.cache.setCookie("follows", followstr, -1);

	setPushAttributes();
	if(suppressBackup == undefined || suppressBackup == false)
		backupToCloud();
}

function signupSubmit()
{
	tmpNAME = $('#signupnickname').val();
	if( tmpNAME.length == 0 ) return;
	registerUserName(tmpNAME);

	if( TUTORIAL_DONE == 0 )
	{
		IS_TUTORIAL = true;
		TUTORIAL_STEP = 1;
		showTutorial(TUTORIAL_STEP);
	}
}

function help1Submit()
{
	$("#helppopup1").hide();
	$("#helppopup2").show();
}

function help2Submit()
{
	$("#helppopup2").hide();
	$("#helppopup3").show();
}

function help3Submit()
{
	$("#helppopup3").hide();
	$("#helppopup1").show();
}

function updateGroupUI()
{
	for( groupid in CHAT_ROOMS )
	{
		var group = CHAT_ROOMS[groupid];
		if( $('#groupheader_'+group.id).length == 0 )
		{
			var divstr = $('#groupinfo').html();
			divstr = divstr.trim();
			if(divstr[divstr.length-1] == '\n') divstr = divstr.substr(0,divstr.length-1);
			divstr = divstr.replace(/zzz/g, group.id);
			divstr = divstr.replace(/yyy/g, group.name);

			$('#groupsScroller').append($(divstr));
		}

		$('#grouppeoplecount_'+group.id).html("Members (" + $(group.members).count() +")");
		$('#grouppeople_'+group.id).empty();
		for( member in group.members )
		{
			$('#grouppeople_'+group.id).append($("<div>" + group.members[member] + "</div>"))
		}

		( ACTIVE_CHAT == group.id ) ? $('#group_chat_active_' + group.id).show() : $('#group_chat_active_' + group.id).hide();
		if ($(CHAT_ROOMS).count() == 1)
		    $('#subgroup_' + group.id).show();
	}

	if( ACTIVE_CHAT.length > 0 )
	{
		if( ACTIVE_CHAT.indexOf('-_-') == -1 )
		{
			$('#player_station_header').html("Chat:");
			$('#player_station_chat').html(ALL_STATIONS[ACTIVE_CHAT].name);
		}
		else
		{
			$('#player_station_header').html("Group:");
			$('#player_station_chat').html(CHAT_ROOMS[ACTIVE_CHAT].name);
		}
	}
}

function inviteEmail(group)
{
	if( AppMobi.isxdk == true )
	{
		alert('Email for group ' + group);
	}
	else
	{
		var link = "http://services.v2.flycast.fm/signup.aspx?refer=email&gid=" + escape(group) + "&gname=" + escape(CHAT_ROOMS[group].name) + "&iuser=" + escape(USER_NAME);
		var body = "Hey everyone,<br/>I've been listening to lots of great stations on FlyCast Select.<br/>Join my chat group '" + CHAT_ROOMS[group].name + "' so we can chat while we listen!<br/>Just click the link below.<br/><a href='" + link + "'>Get FlyCast Select Now</a>";
		AppMobi.device.sendEmail(body, "", "Check out FlyCast Select", true, "", "" );
	}
}

function inviteSMS(group)
{
	if( AppMobi.isxdk == true )
	{
		alert('SMS for group ' + group);
	}
	else
	{
		var link = "http://services.v2.flycast.fm/signup.aspx?refer=sms&gid=" + escape(group) + "&gname=" + escape(CHAT_ROOMS[group].name) + "&iuser=" + escape(USER_NAME);
		var body = "Join my chat group '" + CHAT_ROOMS[group].name + "' in FlyCast Select so we can chat while we listen! " + link;
		AppMobi.device.sendSMS(body, "");
	}
}

var facebookgroup = "";
function inviteFacebook(group)
{
	facebookgroup = group;
	if( false && AppMobi.isxdk == true )
	{
		alert('FB for group ' + group);
	}
	else
	{
		var params = { message : 'Hey everyone, join my chat group!' };
		AppMobi.facebook.showAppRequestDialog(params);
		//var e = document.createEvent('Events');e.initEvent('appMobi.facebook.dialog.complete',true,true);e.success=true;e.raw='?request=250232425068641&to%5B0%5D=100003090414919';e.request=250232425068641;e.to=[100003090414919,];document.dispatchEvent(e);
	}
}

fbinviteuser = false;
function handleFacebookDialog(e)
{
	if( typeof( e.request ) != "undefined" )
	{
		var group = facebookgroup;
		var body = "";
		body += "name=FlyCast Select&";
		body += "message=Join my chat group '" + CHAT_ROOMS[group].name + "' in FlyCast Select!&";
		body += "caption=talk and music on your mobile device&";
		body += "description=This is a great app to listen to the best music and talk stations and chat with other users about the topics of the day. Click this link on your mobile iOS or Android device to join the fun!&";
		body += "picture=http://am-site.s3.amazonaws.com/app.7dd1b070-1f9e-4eda-a3c3-63700a6afa46/226301c9-c07d-40d4-943f-80cbefc703ec/icon.png&";
		body += "link=http://services.v2.flycast.fm/signup.aspx?refer=facebook^gid=" + escape(group) + "^gname=" + escape(CHAT_ROOMS[group].name) + "^iuser=" + escape(USER_NAME);
		var list = [];
		for( var i = 0; i < e.to.length; i++ )
		{
			var who = e.to[i];
			var post = {};
			post.method = "POST";
			post.relative_url = who + "/feed/";
			post.body = body;

			list.push( post );
		}
		var batch = { batch : JSON.stringify(list) };

		fbinviteuser = true;
		AppMobi.facebook.requestWithGraphAPI("me" ,"POST", JSON.stringify(batch) );
	}
}
document.addEventListener('appMobi.facebook.dialog.complete', handleFacebookDialog, false);

function handleFacebookResponse(e)
{
	if( fbstationpost == true )
	{
		fbstationpost = false;
		if( e.success == true )
		{
			url_sharing_status('Clip Shared on Facebook!', 0);
			if( Achievements.earned(ACHIEVEMENT_POSTER_CHILD) == false )
			{
				Achievements.earn(ACHIEVEMENT_POSTER_CHILD);
				AppMobi.notification.alert("You've just earned the POSTER CHILD badge", "Congratulations!", "OK");
			}
			earnComments();
		}
		else
		{
			url_sharing_status('Error Sharing on Facebook!', 100);
		}
	}
	else if( fbinviteuser == true )
	{
		fbinviteuser = false;
		if( e.success == true )
		{
			if( Achievements.earned(ACHIEVEMENT_FRIEND_INVITE) == false )
			{
				Achievements.earn(ACHIEVEMENT_FRIEND_INVITE);
				AppMobi.notification.alert("You've just earned the FRIENDLY FELLOW badge", "Congratulations!", "OK");
			}
			earnComments();
		}
	}
}
document.addEventListener('appMobi.facebook.request.response', handleFacebookResponse, false);

function getStations()
{
	var url = "http://services.v2.flycast.fm/services.aspx?cmd=getstations" + "&rand=" + Math.random();
	var params = new AppMobi.Device.RemoteDataParameters();
	params.url = url;
	params.id = 'stations';
	AppMobi.device.getRemoteDataExt(params);
}

function launchChatForm()
{
	if( IS_TUTORIAL == true && TUTORIAL_STEP != 5 ) return;
	(curChat == "nochatmsg" ) ? $('#chat_reply_to').hide() : $('#chat_reply_to').show();
	$('#num_comments_rem').html( (COMMENT_INFINITY == 1 ) ? "&#8734" : COMMENT_COUNT );
    $('#chatGroup').hide();
    $('#chatForm').toggle();
    if( $('#chatForm').hidden() ) showChatPopup("nochatmsg");
    if( IS_TUTORIAL == true && TUTORIAL_STEP == 5 ) showTutorial( ++TUTORIAL_STEP );
}

function updateChatGroupUI()
{
	var index = 0;
	groupstr = "";
	for( room in CHAT_ROOMS )
	{
		index++;
		var group = CHAT_ROOMS[room];
		var selected = ( group.id == ACTIVE_CHAT ) ? "checked" : "";
		groupstr += '<li><input ' + selected + ' type="radio" value="' + group.id + '" id="' + index +'" name="station" class="jq-ui-forms" onclick="changeChatGroup(\'' + group.id + '\');" /><label for="' + index+ '">' + group.name + '</label></li>';
	}

	if( ACTIVE_STATION.length > 0 )
	{
		var station = ALL_STATIONS[ACTIVE_STATION];
		var selected = ( station.id == ACTIVE_CHAT ) ? "checked" : "";
		groupstr += '<li><input ' + selected + ' type="radio" value="' + station.id + '" id="' + index +'" name="station" class="jq-ui-forms" onclick="changeChatGroup(\'' + station.id + '\');" /><label for="' + index+ '">' + station.name + '</label></li>';
	}

	$('#chatgroup_list').empty();
	$('#chatgroup_list').append($(groupstr));
}

function launchChatGroup()
{
    $('#chatForm').hide();
    $('#chatGroup').toggle();
    updateChatGroupUI();
}

function changeChatGroup(channel)
{
	switchChatGroup(channel);
	$('#chatGroup').hide();
}

function showAddGroup() {
	if( IS_TUTORIAL == true && TUTORIAL_STEP != 9 ) return;

	if( IS_TUTORIAL == false )
	{
		$('#addGroupBtn').hide();
		$('#cancelAddGroupBtn').show();
		$('#addGroup').toggle();
	}
	else
	{
		showTutorial( ++TUTORIAL_STEP );
		submitAddGroupDone();
	}
}

function cancelAddGroup() {
    $('#cancelAddGroupBtn').hide();
    $('#addGroup').toggle();
    $('#addGroupBtn').show();
}

function submitAddGroup() {
	purchaseRing();
}

function submitAddGroupDone() {
    $('#cancelAddGroupBtn').hide();
    $('#addGroup').toggle();
    $('#groupName').toggle();
}

function addChatGroup(groupid, name)
{
	CHAT_ROOMS[groupid] = {};
	CHAT_ROOMS[groupid].members = {}
	CHAT_ROOMS[groupid].members[AppMobi.device.uuid] = USER_NAME;
	CHAT_ROOMS[groupid].id = groupid;
	CHAT_ROOMS[groupid].name = name;
}

setupgroup = "";
function submitGroupName() {

	var name = $('#group_name').val();
	if( name.length == 0 ) return;

	var groupid = AppMobi.device.uuid + "-_-" + parseInt(Math.random()*15485863) % 104729;
	setupgroup = groupid;

	addChatGroup(groupid, $('#group_name').val());
	$('#group_name').val("");

	if( IS_TUTORIAL == false && Achievements.earned(ACHIEVEMENT_CHATTY_CATHY) == false )
	{
		Achievements.earn(ACHIEVEMENT_CHATTY_CATHY);
		AppMobi.notification.alert("You've just earned the CHATTY CATHY badge", "Congratulations!", "OK");
	}
	updateGroupUI();
	updateChatGroupUI();
	earnComments();

    $('#groupName').toggle();
    $('#groupInvitations').toggle();
    if( IS_TUTORIAL == true )
    {
		hideGroupInvitation();
		showTutorial( ++TUTORIAL_STEP );
	}
}

function hideGroupInvitation() {
	$('#addGroup').hide();
    $('#groupInvitations').toggle();
    $('#addGroupBtn').show();
    checkGroupLimit();
    setupgroup = "";
}

var curChat = "nochatmsg";
function showChatPopup(chat) {
    if (curChat && chat != curChat) {
        hideChatPopup();
    }

	if ($("#" + chat).get())
	{
		if ($("#" + chat).hasClass('highlighted')) {
			hideChatPopup();
		}
		else {
			var offset = $("#" + chat).offset();
			$("#" + chat).addClass('highlighted');
			$('#chatPopup').show();
			$('#chatPopup').css('top', (offset.top-150) + 'px');
		}
	}
    curChat = chat;
}

function hideChatPopup() {
    $("#" + curChat).removeClass('highlighted');
    $('#chatPopup').hide();
    // curChat = "nochatmsg"; -- this breaks reply
}

function acceptGroupInvite() {
    $('#groupInvited').hide();
    joinGroupPush();
}
function declineGroupInvite() {
    $('#groupInvited').hide();
}
function doGroupInvite(group)
{
	$('#chatInviteGroup').hide();
	if( typeof( group ) == "undefined") return;

	var time = getTimecode();
	var ref = (curChat == "nochatmsg" ) ? "" : curChat.substring(8);
	var user = GROUP_CHATS[ACTIVE_CHAT][ref].data.user;
	var filter = "[s3=" + user + "]";
	var members = JSON.stringify(CHAT_ROOMS[group].members);
	sendPush( CHAT_ROOMS[group].name, time, "invite", CHAT_ROOMS[group].id, AppMobi.device.uuid, USER_NAME, 'groupinvite', filter, user, members, false );

	showChatPopup("nochatmsg");
}

function doGroupJoin(group)
{
	var time = getTimecode();
	var filter = "[s1 LIKE %" + group + "%]";
	sendPush( "Welcome", time, "join", CHAT_ROOMS[group].id, AppMobi.device.uuid, USER_NAME, 'groupjoin', filter, "", "", false );
}

function doGroupUserNameChange()
{
	for(group in CHAT_ROOMS)
	{
		var time = getTimecode();
		var filter = "[s1 LIKE %" + group + "%]";
		sendPush( "Welcome", time, "join", CHAT_ROOMS[group].id, AppMobi.device.uuid, USER_NAME, 'groupchange', filter, "", "", false );
	}
}

function inviteGroup()
{
	var index = 0;
	groupstr = "";
	for( room in CHAT_ROOMS )
	{
		var group = CHAT_ROOMS[room];
		groupstr += '<li><input type="radio" value="' + group.id + '" id="' + index +'" name="station" class="jq-ui-forms" onclick="doGroupInvite(\'' + group.id + '\');" /><label for="' + index+ '">' + group.name + '</label></li>';
		index++;
	}
	groupstr += '<li><input type="radio" value="" id="' + index +'" name="station" class="jq-ui-forms" onclick="doGroupInvite();" /><label for="' + index+ '">Cancel Group Invite</label></li>';

	if( index == 0 )
	{
		AppMobi.notification.alert("You must create a group first before you can invite others.", "Group Invite", "OK");
	}
	else
	{
		hideChatPopup();
		$('#chatinvitegroup_list').empty();
		$('#chatinvitegroup_list').append($(groupstr));
		$('#chatInviteGroup').show();
	}
}

function buyMoreComments(ver)
{
	var lifetime = $('#lifetimecomments'+ver).get().checked;
	purchaseComments(lifetime);
}

function finishBuyCommments(unlimited)
{
	if( unlimited == true ) COMMENT_INFINITY = 1;
	else COMMENT_COUNT += 25;

	$('#num_comments_left').html( (COMMENT_INFINITY == 1 ) ? "&#8734" : COMMENT_COUNT );
	$('#num_comments_rem').html( (COMMENT_INFINITY == 1 ) ? "&#8734" : COMMENT_COUNT );
	saveAppState();
	$('#getMoreModal').hide();
	$('#getMoreModalProfile').hide();
	setupComments();
}

function setupComments() {
    if (COMMENT_INFINITY==1) {
        $('#num_comments_left_1').hide();
        $('#num_comments_left_1_label').hide();
        $('#get_more_button_1').hide();
        $('#unlimited_message_1').show();
        $('#comments_left').hide();
    }
}

function replyTo()
{
	hideChatPopup();
	launchChatForm();
}

function updateFollowUI()
{
	var favstr = "";

	for( fav in FOLLOWS )
	{
		var follow = FOLLOWS[fav];
		favstr += "<li class='favorites_loading'>" + follow + "<a class='favorites_remove' href='javascript: askUnfollowUser(\"" + fav + "\");'><img src='images/del-fav.png'></a></li>";
	}

	if( favstr.length == 0 )
	{
		favstr = "<li>To add a user as a favorite, do a long press on one of their chat comments.</li>";
	}

	$('#favoriteSubItems').empty();
	$('#favoriteSubItems').append(favstr);
}

function followUser()
{
	try
	{
		var chatid = curChat.substring(8);
		var chat = GROUP_CHATS[ACTIVE_CHAT][chatid];
		FOLLOWS[chat.data.user] = chat.data.name;
		saveAppState();
	}
	catch(ex) { console.log("bad message in followUser -- " + ex.message); }

	var time = getTimecode();
	var filter = "[s3=" + chat.data.user + "]";
	sendPush( "Hello", time, "follow", ACTIVE_CHAT, AppMobi.device.uuid, USER_NAME, 'follower', filter, chat.data.user, "", false );

	showChatPopup("nochatmsg");
	if( Achievements.earned(ACHIEVEMENT_CYBER_STALKER) == false )
	{
		Achievements.earn(ACHIEVEMENT_CYBER_STALKER);
		AppMobi.notification.alert("You've just earned the CYBER STALKER badge", "Congratulations!", "OK");
	}
	updateFollowUI();
}

unfollowuser = "";
function askUnfollowUser(user)
{
	unfollowuser = user;

	AppMobi.notification.confirm("Are you sure you want to stop following '" + FOLLOWS[user] + "' ?", 'unfollow', "Confirm unfollow", "Yes", "No");
}

function unfollowUser()
{
	delete FOLLOWS[user];
	saveAppState();

	updateFollowUI();
	unfollowuser = "";
}

function receiveConfirm(e)
{
	if( e.id == 'unfollow' )
	{
		if( e.success == true && e.answer == true ) unfollowUser();
		else unfollowuser = "";
	}
	else if( e.id == 'unchat' )
	{
		if( e.success == true && e.answer == true ) leaveChatGroup();
		else leavegroup = "";
	}
}
document.addEventListener('appMobi.notification.confirm', receiveConfirm, false);

function toggleThread(chatid)
{
	$('.'+chatid).toggle();
}

function collapseThread()
{
	$('.'+curChat).hide();
	showChatPopup("nochatmsg");
}

function updateChatMessages()
{
	var chatMessages = [];
	//copy messages from object into array and sort
	for( chat in GROUP_CHATS[ACTIVE_CHAT] )
		chatMessages.push(GROUP_CHATS[ACTIVE_CHAT][chat]);
	chatMessages.sort(sortChatMessages);

	//resest chat list and display sorted messages
	resetChatList(false);
	for( chat in chatMessages )
		addChatMessage(chatMessages[chat]);
	autoScrollChatMessages();
}

function sortChatMessages(thisObject,thatObject) {
	if (thisObject.data.time > thatObject.data.time)
		return 1;
	else if (thisObject.data.time < thatObject.data.time)
		return -1;
	return 0;
}

function tutorialBadges()
{
	$('#profileScroller').scroller().scrollTo({x:0,y:-100},0);
	$.ui.loadContent("#profile");
	toggleCategory("station_leader_"+ACTIVE_STATION+"SubItems","imgstation_leader_"+ACTIVE_STATION);
}

function autoScrollChatMessages()
{
	if($('#chatScroller').scroller() != undefined)
	{
		scrollPos = parseInt($("#chatlog").css('height')) - parseInt($("#chatScroller").css('height'));
		if(scrollPos > 0)
			scrollPos = 0;
		$('#chatScroller').scroller().scrollTo({x:0,y:scrollPos},0);
	}
}

function submitChat()
{
	var chat = $('#chatmsg').val();
	if( chat.length == 0 ) return;
	if( IS_TUTORIAL == true && TUTORIAL_STEP != 6 ) return;

	var sent = sendChat();
	if( sent == true )
	{
		$('#chatForm').hide();
		showChatPopup("nochatmsg");
	}

	if( IS_TUTORIAL == true && TUTORIAL_STEP == 6 )
	{
		$('#chatScroller').scroller().scrollTo({x:0,y:0},0);
		showTutorial( ++TUTORIAL_STEP );
		document.getElementById("tutorialMask").style.opacity = 0.05;
		var chatrow = document.getElementById("chatlist").firstChild;
		showChatPopup(chatrow.id);
	}
}

function earnComments()
{
	COMMENT_COUNT += 5;
	if( IS_TUTORIAL == false && EARN_PROMPT == 0 )
	{
		EARN_PROMPT = 1;
		AppMobi.notification.alert("You've just earned 5 more comments. Keep posting to social sites, creating groups and getting replies to your comments to earn more.", "Way To Go!", "OK");
	}
	saveAppState();
}

function switchChatGroup(group)
{
	if( group != ACTIVE_CHAT )
	{
		ACTIVE_CHAT = group;
		updateGroupUI();
		saveAppState();
		updateChatGroupUI();
		updateChatMessages();
	}
}

leavegroup = "";
function askLeaveChatGroup(group)
{
	leavegroup = group;
	AppMobi.notification.confirm("Are you sure you want to leave '" + CHAT_ROOMS[group].name + "' ?", 'unchat', "Confirm leaving", "Yes", "No");
}

function leaveChatGroup()
{
	var group = leavegroup;

	delete CHAT_ROOMS[group].members[AppMobi.device.uuid];
	delete CHAT_ROOMS[group];
	saveAppState();
	$('#groupheader_'+group).remove();

	var time = getTimecode();
	var filter = "[s1 LIKE %" + group + "%]";
	sendPush( "Goodbye", time, "leave", group, AppMobi.device.uuid, USER_NAME, 'groupleave', filter, "", "", true );
	checkGroupLimit();
	updateChatGroupUI();
	leavegroup = "";
}

// TWITTER URL SHARING
//========================================================================
function handleProtectedData(e)
{
	var response = document.getElementById('response');
	if(e.id = 'tweet')
	{
		if(e.success != true)
		{
			url_sharing_status('Error Posting To Twitter!', 100);
		}
		else
		{
			url_sharing_status('Clip Shared on Twitter!', 0);
			if( Achievements.earned(ACHIEVEMENT_TWITTERIFIC) == false )
			{
				Achievements.earn(ACHIEVEMENT_TWITTERIFIC);
				AppMobi.notification.alert("You've just earned the TWITTERIFIC badge", "Congratulations!", "OK");
			}
			earnComments();
		}
		sharingTwitter = false;
	}
}
document.addEventListener('appMobi.oauth.protected.data', handleProtectedData, false);

function url_sharing_status(status, step)
{
	$("#socialSpinner").show();
   	switch (step) {
        case 0:
            $("#socialMessage").text(status);
            $("#socialSpinner").hide();
            break;
        case 1:
            $("#socialImage").attr("src", "images/postclip_icon1.png");
            $("#socialMessage").text(status);
            $("#socialSharingModal").show();
            break;
        case 2:
            $("#socialImage").attr("src", "images/postclip_icon2.png");
            $("#socialMessage").text(status);
            $("#socialSharingModal").show();
            break;
        case 3:
            $("#socialImage").attr("src", "images/postclip_icon3.png");
            $("#socialMessage").text(status);
            $("#socialSharingModal").show();
            break;
        case 100:
            $("#socialMessage").text(status);
            $("#socialSharingModal").show();
            $("#socialSpinner").hide();
            break;
        default:
    }
}

var sharingTwitter = false;
var sharingFacebook = false;

function showTwitterMessageScreen() {
	if( IS_TUTORIAL == true ) return;
	if( ACTIVE_STATION == 0 )
	{
		AppMobi.notification.alert("You can't post clips of user specified stations.", "Can't post", "OK");
		return;
	}
	
	var currentStationData = ALL_STATIONS[ACTIVE_STATION];
    $("#socialSharingMessageModal").show();
    $("#socialSharingMessageModal").addClass("showTwitter").removeClass("showFB");
    $("#socialSharingMessage").text("Check out this awesome clip from " + currentStationData.name);
}

function showFBMessageScreen() {
	if( IS_TUTORIAL == true ) return;
	if( ACTIVE_STATION == 0 )
	{
		AppMobi.notification.alert("You can't post clips of user specified stations.", "Can't post", "OK");
		return;
	}
	
	var currentStationData = ALL_STATIONS[ACTIVE_STATION];
    $("#socialSharingMessageModal").show();
    $("#socialSharingMessageModal").addClass("showFB").removeClass("showTwitter");
    $("#socialSharingMessage").text("Check out this awesome clip from " + currentStationData.name);
}

function shareTwitter()
{
    $("#socialSharingMessageModal").hide();
    $("#socialSharingMessageModal").removeClass("showFB").removeClass("showTwitter");
	if( sharingTwitter == true || sharingFacebook == true ) return;
	sharingTwitter = true;
	getClipUrl();
}

function shareFacebook()
{
    $("#socialSharingMessageModal").hide();
    $("#socialSharingMessageModal").removeClass("showFB").removeClass("showTwitter");
	if( sharingTwitter == true || sharingFacebook == true ) return;
	sharingFacebook = true;
	getClipUrl();
}

function doShareTwitter(response)
{
	var currentStationData = ALL_STATIONS[ACTIVE_STATION];
	//tweetString = "Check out this awesome clip from " + currentStationData.name + ": ";
	tweetString = $("#socialSharingMessage").val() + " ";
	tweetString += response;

	var params = new AppMobi.OAuth.ProtectedDataParameters();
	params.service = 'Twitter';
	params.url = 'https://api.twitter.com/statuses/update.xml';
	params.id = 'tweet';
	params.body = "status=" + tweetString;
	params.method = "POST";
	AppMobi.oauth.getProtectedData(params);
	url_sharing_status("Posting To Social Media", 3);
}

function addFavoriteStation()
{
	var station = {"id":"0","order":"0","popular":"0","name":"User Station","type":"Favorite","image":"","url":"","mediatype":"audio/mp3","bitrate":"32"};
	station.image = AppMobi.webRoot + "images/shoutcast.png";
	station.url = FAV_STATION;
	ALL_STATIONS[0] = station;
}

function changeFavorite(stationurl)
{
	FAV_STATION = stationurl.toLowerCase();
	addFavoriteStation();
	saveAppState();
	updateStationsUI();
}

var tutorialPhoneTop = ["300px","60px","50px","0px","110px","280px","130px","0px","100px","380px","230px","300px","50px","320px"];
var tutorialTabletTop = ["400px","90px","100px","100px","160px","340px","30px","160px","80px","400px","230px","300px","50px","340px"];
function showTutorial(step)
{
	var top = ( istablet == true ) ? tutorialTabletTop[step-1] : tutorialPhoneTop[step-1];
    $("#tutorials").css("top",top);
    $("#tutorials").css("zIndex", 9999);
    $("#tutorials").show();

    switch (step) {
        case 1:
        	toggleCategory('popularSubItems','imgPopular');
            break;
        case 2:
            break;
        case 3:
            break;
        case 4:
            break;
        case 5:
            break;
        case 6:
            break;
        case 7:
            break;
        case 8:
            break;
        case 9:
            break;
        case 10:
            break;
        case 11:
            break;
        case 12:
            break;
        case 13:
            break;
        case 14:
            break;
        default:
            break;
    }

    $("#tutorials > div").hide();
    $("#tutStep"+step).show();
    $("#tutHeader").show();
    $("#tutorialMask").show();
}

function hideTutorial() {
    $("#tutorials").hide();
}

function completeTutorial()
{
	IS_TUTORIAL = false;
	TUTORIAL_DONE = 1;
	$('#profileScroller').scroller().scrollTo({x:0,y:-100},0);
	toggleCategory("achievementsSubItems","imgAchievements3");
	toggleCategory("station_leader_"+ACTIVE_STATION+"SubItems","imgstation_leader_"+ACTIVE_STATION);
	Achievements.earn(ACHIEVEMENT_GLAD_GRAD);
	AppMobi.notification.alert("You've just earned the GLAD GRAD badge", "Congratulations!", "OK");
	saveAppState();
}

fbstationpost = false;
function doShareFacebook(response)
{
	var index = response.indexOf("tinyurl.com/");
	var tiny = response.substring(12+index);
	var link = "http://services.v2.flycast.fm/redir.aspx?tiny=" + tiny;
	var datestr = new Date().toUTCString();

	var body = {};
	body.name = "Play this audio clip from " + ALL_STATIONS[ACTIVE_STATION].name + " at " + datestr;
	//body.name = "FlyCast Select";
	//body.message = "Check out this awesome clip from '" + ALL_STATIONS[ACTIVE_STATION].name + "'";
	body.message = $("#socialSharingMessage").val();
	body.caption = "talk and music from FlyCast Select";
	body.description = "This is a great app to listen to the best music and talk stations and chat with other users about the topics of the day. Click this link on your mobile iOS or Android device to join the fun!";
	body.picture = "http://am-site.s3.amazonaws.com/app.7dd1b070-1f9e-4eda-a3c3-63700a6afa46/226301c9-c07d-40d4-943f-80cbefc703ec/icon.png";
	body.link = link;

	fbstationpost = true;
	url_sharing_status("Posting To Social Media", 3);
	AppMobi.facebook.requestWithGraphAPI("/me/feed" ,"POST", JSON.stringify(body) );
}

function getClipUrl()
{
	url_sharing_status("Creating Audio Clip", 1);
	station = ACTIVE_STATION;
	var url = "http://services.v2.flycast.fm/services.aspx?cmd=getclipurl&id=" + station + "&rand=" + Math.random();
	console.log(url);
	var params = new AppMobi.Device.RemoteDataParameters();
	params.url = url;
	params.id = 'share_clipurl';
	AppMobi.device.getRemoteDataExt(params);
}

CALLBACKS['share_clipurl'] = function(e)
{
	var response = eval('('+e.response+')');
	if( typeof(response) == "undefined" || typeof(response.rtn) == "undefined" || response.rtn != "ok" )
	{
		e.success = false;
		url_sharing_status('Error Creating Audio Clip', 0);
		sharingTwitter = false;
		sharingFacebook = false;
	}

	if( e.success == true )
	{
		var url = "http://tinyurl.com/api-create.php?url=" + response.clipurl;
		console.log(url);
		var params = new AppMobi.Device.RemoteDataParameters();
		params.url = url;
		params.id = 'share_tinyurl';
		AppMobi.device.getRemoteDataExt(params);
		url_sharing_status("Saving Audio Clip",2);
	}
}

CALLBACKS['share_tinyurl'] = function(e)
{
	var response = e.response;
	if( e.success == true && response != "Error")
	{
		if( sharingFacebook == true ) doShareFacebook(response);
		if( sharingTwitter == true ) doShareTwitter(response);
	}
	else
	{
		url_sharing_status('Tiny URL Error', 100);
		sharingFacebook = false;
		sharingTwitter = false;
	}
}
